﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Threading;

namespace HandlingExceptionsUsingTryCatch
{
    /// <summary>
    /// This demo shows how to use a somewhat conventional try/catch 
    /// for Exceptions that are thrown from a Task, it makes use of AggregateException
    /// </summary>
    class Program
    {
        static void Main(string[] args)
        {

            // create the task
            Task<List<int>> taskWithFactoryAndState = Task.Factory.StartNew<List<int>>((stateObj) =>
            {
                List<int> ints = new List<int>();
                for (int i = 0; i < (int)stateObj; i++)
                {
                    ints.Add(i);
                    if (i > 100)
                    {
                        InvalidOperationException ex =
                            new InvalidOperationException("oh no its > 100");
                        ex.Source = "taskWithFactoryAndState";
                        throw ex;
                    }
                }
                Thread.Sleep(4000);
                Console.WriteLine("Done");
                return ints;
            }, 200);

            Console.WriteLine("All done, press Enter to Quit");

            Console.ReadLine();

        }
    }
}
